337. 打家劫舍 III

337. 打家劫舍 III

题目描述

在上次打劫完一条街道之后和一圈房屋后,小偷又发现了一个新的可行窃的地区。这个地区只有一个入口,我们称之为“根”。 除了“根”之外,每栋房子有且只有一个“父“房子与之相连。一番侦察之后,聪明的小偷意识到“这个地方的所有房屋的排列类似于一棵二叉树”。 如果两个直接相连的房子在同一天晚上被打劫,房屋将自动报警。

计算在不触动警报的情况下,小偷一晚能够盗取的最高金额。

337. 打家劫舍 III_第1张图片

解法一:暴力破解-最优子结构

一共有两种搭配

  1. 爷爷跟孙子:int method1 = root.val+rob(root.left.left)+rob(root.right.right)+rob(root.left.right)+rob(root.right.left)
  2. 两个儿子:int method2 = rob(root.left)+rob(root.right)

4 个孙子偷的钱 + 爷爷的钱 VS 两个儿子偷的钱 哪个组合钱多,就当做当前节点能偷的最大钱数。这就是动态规划里面的最优子结构

​ int result = Math.max(method1, method2);

class Solution {
    public int rob(TreeNode root) {
        if(root==null) return 0;
        int money = root.val;
        if(root.left!=null){
            money+=rob(root.left.left)+rob(root.left.right);
        }
        if(root.right!=null){
            money+=rob(root.right.left)+rob(root.right.right);
        }
        return Math.max(money,rob(root.left)+rob(root.right));
    }
}

337. 打家劫舍 III_第2张图片


解法二:记忆化-解决重复子问题

class Solution {
    Map<TreeNode,Integer> map;
    public int rob(TreeNode root) {
        map = new HashMap<>();
        return robhelper(root);
    }
    public int robhelper(TreeNode root){
        if(root==null) return 0;
        if(map.containsKey(root)) return map.get(root);
        int money = root.val;
        if(root.left!=null){
            money+=robhelper(root.left.left)+robhelper(root.left.right);
        }
        if(root.right!=null){
            money+=robhelper(root.right.left)+robhelper(root.right.right);
        }
        int result = Math.max(money,robhelper(root.left)+robhelper(root.right));
        map.put(root,result);
        return result;
    }
}

337. 打家劫舍 III_第3张图片

解法三:定义状态

每个结点可选择偷与不偷

  • 每个节点可选择偷或者不偷两种状态,根据题目意思,相连节点不能一起偷
  • 我们使用一个大小为 2 的数组来表示 int[] res = new int[2] 0 代表不偷,1 代表偷
  • 任何一个节点能偷到的最大钱的状态可以定义为:
    • 当前节点选择不偷:当前节点能偷到的最大钱数 = 左孩子能偷到的钱 + 右孩子能偷到的钱
    • 当前节点选择偷:当前节点能偷到的最大钱数 = 左孩子选择自己不偷时能得到的钱 + 右孩子选择不偷时能得到的钱 + 当前节点的钱数
      表示为公式如下
root[0] = Math.max(rob(root.left)[0], rob(root.left)[1]) + Math.max(rob(root.right)[0], rob(root.right)[1])
root[1] = rob(root.left)[0] + rob(root.right)[0] + root.val;
class Solution {
    Map<TreeNode,Integer> map;
    public int rob(TreeNode root) {
        map = new HashMap<>();
        int[] result = robhelper(root);
        return Math.max(result[0],result[1]);
    }
    public int[] robhelper(TreeNode root){
        if(root==null) return new int[2];
        int[] result = new int[2];
        //存储左右结点返回的结果数组
        int[] left = robhelper(root.left);
        int[] right = robhelper(root.right);
        //对结果数组赋值
        result[0]=Math.max(left[0],left[1])+Math.max(right[0],right[1]);
        result[1] = left[0]+right[0]+root.val;
        //返回结果数组
        return result;
    }
}

337. 打家劫舍 III_第4张图片

你可能感兴趣的:(leecode,算法,java,leetcode,二叉树,数据结构)